import { BundlingOptions } from './types';
/**
 * Base properties for a Cargo project.
 *
 * RustFunctionProps and RustExtensionProps cannot inherit from this interface
 * because jsii only supports direct inheritance from a single interface.
 */
interface CargoProject {
    readonly bundling?: BundlingOptions;
    readonly binaryName?: string;
    readonly manifestPath?: string;
    readonly gitRemote?: string;
    readonly gitReference?: string;
    readonly gitForceClone?: boolean;
}
export interface Workspace {
    members: string[];
}
export interface Package {
    name: string;
}
export interface Manifest {
    package?: Package;
    bin?: Package[];
    workspace?: Workspace;
}
export declare function getManifestPath(project: CargoProject): string;
export declare function getManifest(manifestPath: string): Manifest;
export {};
